### Method

# Gio SocketListener accept_socket

since: 2.22

#### Declaration [src]

    GSocket*
    g_socket_listener_accept_socket (
      GSocketListener* listener,
      GObject** source_object,
      GCancellable* cancellable,
      GError** error
    )

#### Description [src]

Blocks waiting for a client to connect to any of the sockets added to the listener. Returns the `GSocket` that was accepted.

If you want to accept the high-level `GSocketConnection`, not a `GSocket`, which is often the case, then you should use `g_socket_listener_accept()` instead.

If `source_object` is not `NULL` it will be filled out with the source object specified when the corresponding socket or address was added to the listener.

If `cancellable` is not `NULL`, then the operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, the error `G_IO_ERROR_CANCELLED` will be returned.

Available since: 2.22

#### Parameters

`source_object`

  Type: `GObject`

  Location where `GObject` pointer will be stored, or `NULL`.

  The argument will be set by the function.
  The argument can be set to `NULL` by the method.
  The argument can be `NULL`.
  The returned data is owned by the instance.

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, `NULL` to ignore.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `GSocket`

A `GSocket` on success, `NULL` on error.

The caller of the method takes ownership of the returned data, and is responsible for freeing it.